/*
    This file is part of KDE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "installersuse.h"

#include "entry.h"

#include "kupdateiface_stub.h"

#include <kmessagebox.h>
#include <klocale.h>
#include <kprocess.h>
#include <kdebug.h>

#include <qwidget.h>

InstallerSuse::InstallerSuse( Engine *e, QWidget *widget )
  : Installer( e, widget )
{
}

void InstallerSuse::doInstall( KNS::Entry *entry )
{
  KURL url = entry->payload();

  kdDebug() << "InstallerSuse::install() " << url << endl;

  QString path = url.path();

  kdDebug() << "PATH: " << path << endl;

  KProcess *proc = new KProcess;

  *proc << "kdesu";
  *proc << "yast2 -i " + path;
  
  connect( proc, SIGNAL( processExited( KProcess * ) ),
    SLOT( slotProcessExited( KProcess * ) ) );
    
  proc->start();  
}

void InstallerSuse::slotProcessExited( KProcess *proc )
{
  delete proc;

  finishInstallation();
}

#include "installersuse.moc"
