/*
   This file is part of the KDE project
   Copyright (C) 2009 by Dmitry Suzdalev <dimsuz@gmail.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef UTILS_H
#define UTILS_H

#include <X11/Xlib.h>
#include <fixx11h.h>

#include <QWidget>

namespace Utils
{
    struct SelectionData
    {
        Atom atom;
        Atom sentinel_atom;
        Atom timestamp_atom;
        Window last_owner;
        bool owner_is_qt;
        Time last_change;
        bool waiting_for_timestamp;
        Time waiting_x_time;
    };

    void updateTimestamp();
    void updateQtOwnership( SelectionData& data );
    bool checkTimestamp( WId winId, Atom xa_timestampAtom, SelectionData& data );
    bool changedTimestamp( WId winId, SelectionData& data, const XEvent& e );
} // namespace Utils

#endif
