/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "tools.h"

#include <Soprano/Model>
#include <Soprano/QueryResultIterator>
#include <Soprano/StatementIterator>

#include <Nepomuk/ResourceManager>

#include "syncfile.h"
#include "changelog.h"


// trueg: at some point this will become a VERY large list
// - maybe it wold be better to not load all the statements
// into memory at once but do something iterative
QList<Soprano::Statement> Nepomuk::getBackupStatements()
{
    const QString query = QString::fromLatin1("select ?r ?p ?o ?g where { graph ?g { ?r ?p ?o. } ?g a nrl:InstanceBase . FILTER(!bif:exists( ( select (1) where { ?g a nrl:DiscardableInstanceBase . } ) )) . }");

    Soprano::Model * model = Nepomuk::ResourceManager::instance()->mainModel();

    return model->executeQuery( query, Soprano::Query::QueryLanguageSparql )
        .iterateStatementsFromBindings( QLatin1String("r"),
                                        QLatin1String("p"),
                                        QLatin1String("o"),
                                        QLatin1String("g") )
        .allStatements();
}


Nepomuk::Sync::SyncFile Nepomuk::createFirstSyncFile()
{
    return Sync::SyncFile( Sync::ChangeLog( getBackupStatements() ) );
}

