/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef MERGERMODEL_H
#define MERGERMODEL_H

#include <QtCore/QAbstractItemModel>
#include <QtCore/QUrl>

namespace Nepomuk {

    struct MergerRecord {
        QUrl uri;
        QUrl prop;
        QString label;
    };
    
    class MergerModel : public QAbstractListModel
    {
        Q_OBJECT
    public:
        MergerModel(QObject* parent = 0);
        virtual ~MergerModel();

        virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
        virtual int rowCount(const QModelIndex& parent = QModelIndex()) const;

        virtual bool removeRows(int row, int count, const QModelIndex& parent = QModelIndex());

        void clearAll();

        MergerRecord record( int row );
        MergerRecord record( const QModelIndex & index );

        void remove( const QModelIndex & index );
        
    public Q_SLOTS:
        void multipleMerge( const QString &uri, const QString &prop );

    private:
        QList<MergerRecord> m_list;
    };

}

#endif // MERGERMODEL_H
