/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef IDENTIFICATION_SET_GENERATOR_P_H
#define IDENTIFICATION_SET_GENERATOR_P_H

#include <QtCore/QSet>
#include <KUrl>

namespace Soprano {
    class Model;
    class Statement;
    class QueryResultIterator;
}

namespace Nepomuk {
    namespace Sync {
        
        class IdentificationSetGenerator {
        public :
            IdentificationSetGenerator( const QSet<KUrl>& uniqueUris, Soprano::Model * m , const QSet<KUrl> & ignoreList = QSet<KUrl>());

            Soprano::Model * model;
            QSet<KUrl> done;
            QSet<KUrl> notDone;

            QList<Soprano::Statement> statements;

            Soprano::QueryResultIterator performQuery( const QStringList& uris );
            void iterate();
            QList<Soprano::Statement> generate();

            static const int maxIterationSize = 50;
        };
    }
}
#endif
