/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MERGEREQUEST_P_H
#define MERGEREQUEST_P_H

#include <QtCore/QPair>
#include <QtCore/QUrl>
#include <QtCore/QMultiHash>
#include <QtCore/QDateTime>
#include <QtCore/QQueue>

#include <Nepomuk/ResourceManager>

#include "syncrequest.h"
#include "resourcelog.h"

#include "changelog.h"
#include "simpleresource.h"

namespace Soprano {
    class Statement;
    class Model;
}

namespace Nepomuk {


    class SyncRequest;

    class SyncRequest::Private
    {
    public:
        Soprano::Model * m_model;

        int m_id;
        static int NextId;

        Sync::ChangeLog m_logFile;
        QDateTime m_minDateTime;

        QList<Sync::SimpleResource> m_jobs;

        /// Contains all the records from the LogFile
        Sync::ResourceLogMap m_hash;

        //ResourceManager * m_resourceManager;
        GraphWrapper m_graphWrapper;

        /**
        * Handles the case when the Resource's metadata has been deleted from
        * the LogFile.
        * \return true if resUri was deleted, false otherwsie
        */
        bool handleResourceDeletion( const QUrl & resUri );

    };
}


#endif // MERGEREQUEST_P_H
