/* This file is part of the KDE Project
   Copyright (c) 2009 Daniel Winter <dw@danielwinter.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef ABSTRACT_FILESYSTEM_HANDLER_H
#define ABSTRACT_FILESYSTEM_HANDLER_H

#include <QObject>

#include <filesystem.h>

namespace Nepomuk
{

class AbstractFilesystemHandler : public QObject
{


public:
    AbstractFilesystemHandler( QObject *parent ) : QObject( parent ) {}
    virtual QList<Filesystem> mountedFilesystems() const = 0;

Q_SIGNALS:
    void filesystemMounted( Filesystem f );
    void filesystemUnmounted( Filesystem f );
};

}

#endif // ABSTRACT_FILESYTSEM_HANDLER_H
