/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mainwindow.h"

#include <KAboutData>
#include <KApplication>
#include <KCmdLineArgs>
#include <KDebug>

int main(int argc, char *argv[])
{
    KAboutData aboutData("nepomuksearchgui", 0,
                         ki18n("Nepomuk Search GUI"),
                         "0.1",
                         ki18n("A GUI for searching on Nepomuk"),
                         KAboutData::License_GPL,
                         ki18n("(c) 2010, Oszkar Ambrus"),
                         KLocalizedString(),
                         "http://nepomuk.kde.org");
    aboutData.addAuthor(ki18n("Oszkar Ambrus"), ki18n("Maintainer"), "aoszkar@gmail.com");
    aboutData.setProgramIconName("nepomuk");

    KCmdLineArgs::init(argc, argv, &aboutData);
    KApplication app;

    MainWindow *window = new MainWindow();
    window->show();

    return app.exec();
}
