/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef RESOURCEEDITPLUGINFACTORY_H
#define RESOURCEEDITPLUGINFACTORY_H

#include <QObject>

#include "nepomuksearchgui_export.h"

class QUrl;

namespace Nepomuk {

    class AbstractResourceEditPlugin;

    /**
     * Factory for AbstractResourceEditPlugin objects
     *
     * @author Oszkar Ambrus aoszkar@gmail.com
     */


    class NEPOMUKSEARCHGUI_EXPORT ResourceEditPluginFactory : public QObject
    {
        Q_OBJECT

    public:
        /*ResourceEditPluginFactory( QObject *parent = 0 );
        ~ResourceEditPluginFactory();
        */

        /**
         * Returns the AbstractResourceEditPlugin for a type. It looks for a plugin
         * for the given type, and if it can't fine one, uses the GenericResourceEditPlugin
         * as a fallback.
         *
         * @param typeUri the URI of the type
         * @return the AbstractResourceEditPlugin for editing resources of the given type
         */
        static AbstractResourceEditPlugin *resourceEditPluginForType(const QUrl &typeUri);

    };

}


#endif //RESOURCEEDITPLUGINFACTORY_H
