/*
 * This file is part of Search Project.
 *
 * Copyright (C) 2007 Daniele Galdi <daniele.galdi@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <kapplication.h>
#include <klocale.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kurl.h>

#include "SearchMainWindow.h"

#include <stdio.h>

int main( int argc, char *argv[] )
{
  KAboutData aboutData( "search-strigi", "nepomuksimplesearch",
			ki18n("Search With Strigi"),
			"0.1",
			ki18n("Search With Strigi based on KDE4"),
			KAboutData::License_GPL,
			ki18n("(c) 2007, Daniele Galdi"), 
			KLocalizedString(),
			"http://daniele.galdi.org" );
  aboutData.addAuthor(ki18n("Daniele Galdi"),ki18n("Maintainer"), "daniele.galdi@kde.org");

  KCmdLineArgs::init( argc, argv, &aboutData );

  KCmdLineOptions options;
  KCmdLineArgs::addCmdLineOptions( options );

  KCmdLineArgs* args = KCmdLineArgs::parsedArgs();
  /*if( !args->count() )
  args->usage();*/

  KApplication app;  
  SearchMainWindow mainWin;
  mainWin.show();

  return app.exec();}

