#!/usr/bin/env python
# -*- coding: utf-8 -*-

 
from PyKDE4.nepomuk import Nepomuk
from PyKDE4.soprano import Soprano
from PyQt4.QtCore import QUrl, QDateTime

import sys

def mergeResources(res, resToMerge):
  for uri in resToMerge:
    Nepomuk.ResourceManager.instance().mainModel().removeAllStatements(Soprano.Node(uri),Soprano.Node(),Soprano.Node())
    sl = Nepomuk.ResourceManager.instance().mainModel().listStatements(Soprano.Node(),Soprano.Node(),Soprano.Node(uri)).allStatements()
    Nepomuk.ResourceManager.instance().mainModel().removeAllStatements(Soprano.Node(),Soprano.Node(),Soprano.Node(uri))
    for s in sl:
      s.setObject(Soprano.Node(res))
      Nepomuk.ResourceManager.instance().mainModel().addStatement(s)


def findMusicAlbumDuplicates():
  "Returns a list of lists of QUrls"
  result = []
  query = "select distinct ?title count(?r) where { ?r a nmm:MusicAlbum . ?r nie:title ?title . }"
  albumTitles = Nepomuk.ResourceManager.instance().mainModel().executeQuery(query,Soprano.Query.QueryLanguageSparql).allBindings()
  for title in albumTitles:
    print "Music Album: %s (%d)" % (title.value(0).toString(),title.value(1).literal().toInt())
    query = "select ?r where { ?r a nmm:MusicAlbum . ?r nie:title \"%s\"^^xsd:string . }" % title.value(0).toString().replace('"','\\"')
    result.append( [ n.uri() for n in Nepomuk.ResourceManager.instance().mainModel().executeQuery(query,Soprano.Query.QueryLanguageSparql).iterateBindings(0).allNodes() ] )
  return result
  

def findTagDuplicates():
  "Returns a list of lists of QUrls"
  result = []
  query = "select distinct ?label count(?r) where { ?r a nao:Tag . ?r nao:prefLabel ?label . }"
  tagLabels = Nepomuk.ResourceManager.instance().mainModel().executeQuery(query,Soprano.Query.QueryLanguageSparql).allBindings()
  for label in tagLabels:
    print "Tag: %s (%d)" % (label.value(0).toString(),label.value(1).literal().toInt())
    query = "select ?r where { ?r a nao:Tag . ?r nao:prefLabel \"%s\"^^xsd:string . }" % label.value(0).toString().replace('"','\\"')
    result.append( [ n.uri() for n in Nepomuk.ResourceManager.instance().mainModel().executeQuery(query,Soprano.Query.QueryLanguageSparql).iterateBindings(0).allNodes() ] )
  return result


print "Merging Music Album Duplicates..."
albums = findMusicAlbumDuplicates()
for duplicates in albums:
  mergeResources(duplicates[0], duplicates[1:])

print "Merging Tag Duplicates..."
tags = findTagDuplicates()
for duplicates in tags:
  mergeResources(duplicates[0],duplicates[1:])
  