/*****************************************************************************
 *   Copyright (C) 2010 by Anselmo Lacerda S. de Melo <anselmolsm@gmail.com> *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 *****************************************************************************/

#ifndef ACTIVITYPOPUP_H
#define ACTIVITYPOPUP_H

#include <Plasma/PopupApplet>

#include "activitypopup_p.h"

class ActivityPopup : public Plasma::PopupApplet
{
public:
    ActivityPopup(QObject *parent, const QVariantList &args);
    ~ActivityPopup();

    void init();
    QGraphicsWidget *graphicsWidget();

protected:
    QScopedPointer<ActivityPopupPrivate> d_ptr;

private:
    Q_DISABLE_COPY(ActivityPopup);
    Q_DECLARE_PRIVATE(ActivityPopup);
};

K_EXPORT_PLASMA_APPLET(activitypopup, ActivityPopup)

#endif
