plasmoid.dataUpdate = function(key, data)
{
    this.setState(data.State);
    this.setCover(data.Artwork);
}

plasmoid.setCover = function(artwork)
{
    if (this.cover != artwork) { //There is a cover which is differrent with what we show right now.
        this.cover = artwork;
        this.update();
    }
}

plasmoid.setState = function(state)
{
    if (this.state != state) {
        if (state == 'paused') {
            this.play.visible = true;
        }

        if (state == 'playing') {
            this.play.visible = false;
        }
    }
}

plasmoid.paintInterface = function(painter)
{
    if(!this.cover) { // plasmoid.dataUpdate() is not called yet.
        return ;
    }
    painter.drawPixmap(plasmoid.rect(), this.cover);
}

plasmoid.doPlay = function()
{
    plasmoid.controller.startOperationCall(plasmoid.controller.operationDescription("play"));
    plasmoid.play.animation.start();
}

plasmoid.aspectRatioMode = Square;
plasmoid.engine          = dataEngine("nowplaying");
plasmoid.player          = plasmoid.engine.sources[0];
plasmoid.controller      = service("nowplaying", plasmoid.player);
plasmoid.cover           = null;
plasmoid.state           = null;

plasmoid.buttons      = new LinearLayout(plasmoid);

plasmoid.play         = new IconWidget();
plasmoid.play.visible = false;
plasmoid.play.setIcon('media-playback-start');
plasmoid.play.clicked.connect(plasmoid.doPlay);

plasmoid.play.animation                 = animation('fade');
plasmoid.play.animation.startOpacity    = 1;
plasmoid.play.animation.targetOpacity   = 0;
plasmoid.play.animation.widgetToAnimate = plasmoid.play;
plasmoid.buttons.addItem(plasmoid.play);

plasmoid.engine.connectSource(plasmoid.player, plasmoid, 500); //Connect at last minute so we make sure everything is in its place