/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PICTURE_CELL_H_
#define PICTURE_CELL_H_

#include "abstractcell.h"

#include <Plasma/Label>

/**
 * Uses a Plasma::Label to display a picture
 */
class PictureCell: public AbstractCell
{
Q_OBJECT

public:
	/**
	 * Constructor
	 * @param id Property key identifying the picture path
	 * @param properties Contacts properties
	 * @param parent Parent widget
	 */
	PictureCell(const QString id, const QVariantMap &properties, QGraphicsWidget *parent)		;

	/** Destructor */
	virtual~ PictureCell();

	/**
	 * Reimplemented from AbstractCell
	 */
	virtual void propertiesChanged(const QVariantMap &properties);

private:
	/** Property key identifying the picture path */
	const QString m_id;

	/** Label used for display purposes */
	Plasma::Label *m_label;
};

#endif // PICTURE_CELL_H_
