
# The dialog class, popup a dialog, this could be used stand alone as the applet, just change initialize() to initialize(arg), and pass arg to super
class PopupDialog < Plasma::Dialog
# When the governor, freq, or cpu changes, call this function, connected via the "connect" call near the end of this class
    slots 'changedSelectionfreq(QListWidgetItem*)',
	  'changedSelectioncpu(QListWidgetItem*)',
	  'changedSelectiongov(QListWidgetItem*)'
# These two are "missing' from Plasma::Applet, there could be more, it's one of the downsides to using Qt::Designer, but I define them and let them
# Be set, but they don't do anything
    attr_accessor :sizeGripEnabled
    attr_accessor :modal
# Initialize - the consutrctor
    def initialize()
# Call Plasma::Dialog.initialize
        super 
# copy the frequency list view when it "comes in" to create a "map" for the selected items
        @freqmap = []

# Give these two some default values, could be "nil" just as easily, but set them to what they "should(tm)" be anyway in case Plasma::Applet gets upgraded 
# to incorporate these
        @modal = false
	@sizeGripEnabled= false
# Have we done the frequency and governor lists yet (Only make them once to avoid extra overhead)
	@donefreq = 0
	@donegov = 0
# Create the new dialog from the Ui compiled file (Note: Should set the GNU here instead of in the UI because of a bug in rbuic4 in my distro that misses adding
# a \ somewhere in the compiled file.
	@realdialog = Ui::Popupdialog.new
# Setup the UI on this Plasma::Dialog
	@realdialog.setupUi(self)
	gplize(@realdialog.gpllabel)
    end

    def fillcpuListView(one)
	@realdialog.cpulistView.clear()
	for line in one
		@realdialog.cpulistView.addItem(line)
	end
    end
# Fill up the governor list widget with , .. governors duh
    def fillgovListViews(one)
# Only do it once.
	@realdialog.govlistView.clear()
#	if @donegov == 0
# Add the default "Select Governor" line, this line really is needed for switching between tabs in certain ui's
# when you switch a tab it will automatically select the top item and send a signal that it was selected
# Although now that the signal has been changed to "pressed" which means mouse down has been clicked (left or right)
# it may not be needed.
		@realdialog.govlistView.addItem("Select Governor")
# add each governor to the governor list widget, it's not a list view!!!
		for line in one
			@realdialog.govlistView.addItem(line)
		end

#		@donegov = 1
		count = 0
# This just sets the highlighted governor to the current one the first time the applet is opened so you can see what you're running
		while (item = @realdialog.govlistView.item(count)) != nil
			if (item.text == @top.governor)
				 @realdialog.govlistView.setCurrentItem(item)
			end
			count += 1
		end
#	end
   end
# Same as governors just up from right here
   def fillfreqListViews(two)
	@realdialog.freqlistView.clear()
#	if @donefreq == 0
		@realdialog.freqlistView.addItem("Select Frequency")
		for line in two
			@realdialog.freqlistView.addItem(line[0])
			@freqmap << [line[1], @realdialog.freqlistView.count()-1]
		end
#		@donefreq = 1
#	end
    end
# the slot functions that get called when a selection is made
    def changedSelectiongov(sel)
# Extract the text from the selection, and call the actual "selection made" function that adds extra logic
	
	if (sel == nil or sel.text == "Select Governor" or sel.text == "Select Frequency")
		return
	end
	changedSelectionreal(sel.text)
    end

    def changedSelectionfreq(sel)
        if (sel == nil or sel.text == "Select Governor" or sel.text == "Select Frequency")
                return
        end
# Send in the intiger value of what row was selected to lookup the real value given by the os
	changedSelectionreal(@realdialog.freqlistView.row(sel))
    end
    def changedSelectioncpu(sel)
	if(sel == nil) 
		return
	end
	@top.activeCpu = @realdialog.cpulistView.row(sel)
	@top.setupDialogDisplay()
	@realdialog.cpulistView.setCurrentRow(@top.activeCpu)
    end
#The actual selection made function, imagine that!
    def changedSelectionreal(sel)
# Add a little isnum function to it, isnum, is it a number?? yay or nay
	    def isnum(string)
	         """Return true if x is a number."""
	        return  string.to_i.to_s == string ? true : false
	    end

# Use the map to substitute the selected value with the value given by the OS
# if sel is not an intiger then it won't be replaced and all is fine
# so this doesn't break passing governor strings through here
	for l in @freqmap
		if(l[1] == sel)
			sel = l[0]
			break
		end
	end
# Start building the command to set the frequency with the system
	cmd = ""
	selection = String.new(sel)

	if( isnum(selection) == true)
		"Set the frequency"
# If it's all numbers, then we definitally want userspace governor
		system("cpufreq-set -c %s -g userspace".sub("%s", @top.activeCpu.to_s))
# And set the command to the numbers with the frequency option on cpufreq-set (-f)
		cmd = "cpufreq-set -c " + @top.activeCpu.to_s + " -f " + selection 
	else
# Governor option
		cmd = "cpufreq-set -c " + @top.activeCpu.to_s + " -g " + selection
	end
# execute the command
	ret = system(cmd)

	if(ret != true)
# If the command failed, we probably don't have permissions, though it could not be installed
# so for now just warn about permissions
		Qt::MessageBox.critical(nil, "No Permissions", "Please run \"chmod +s /usr/bin/cpufreq-set\" until PolicyKit is enabled", KDE::MessageBox::Ok)
	end
# hide the window
	self.hide()
	return true
    end
# Move the window to the best possibile position for it

    def settop(parent)
# Set the parent, make the connections
	@top = parent
# Move me to the best position for me please
# Item was pressed! Clicked on, selection has been made yay! process it with the SLOT on self (me, myself, this object here right now hah gatta love comments)
        connect(@realdialog.govlistView, SIGNAL("itemPressed(QListWidgetItem*)"), self, SLOT('changedSelectiongov(QListWidgetItem*)'))
        connect(@realdialog.freqlistView, SIGNAL("itemPressed(QListWidgetItem*)"), self, SLOT('changedSelectionfreq(QListWidgetItem*)'))
	connect(@realdialog.cpulistView, SIGNAL("itemPressed(QListWidgetItem*)"), self, SLOT('changedSelectioncpu(QListWidgetItem*)'))
    end
end


### No Longer Used, saved for historical purposes? ###


# The main pushbutton! Updates itself every second with information from the parent class
# Sets a callback to show() the qobj (which is the Dialog above this class)
class MyButton < Plasma::PushButton
	attr_writer :qobj
	def initialize(parent, text, qobj)
		@qobj = qobj
		super(parent)
		self.setText(text)
                @clickedyet = 0
		connect(self, SIGNAL('clicked()')) { 
			# Create a function and call it
			def click(parent) # Parent is the applet, @qobj is the dialog
				if @clickedyet == 0
					# Some bug doesn't put it at the "right" position the first time so it shows, then hides, then shows again
		                        @qobj.show()
		                        @qobj.moveme(parent)
		                        @qobj.update()
					@qobj.hide()
					@qobj.moveme(parent)
		                        @qobj.update()
					@clickedyet = 1
					# Only run this the first time the window is opened, after that, use the values stored on the window
					# This allows custom positions and resizing - when plasma allows it ... 
				end
				# Show the window (not maximized and restore from the task tray if it's minimized)
				@qobj.showNormal()
				# Raise it above other windows
				@qobj.raise()
				# Give it activation
				@qobj.activateWindow()
				end
			# Do the click.
			click(parent)

		 }
# Make a timer that gets called twice a second (every 500 ms) and sets the text on the button from the "parent.frequency" which is set by "getCurrentMode()" on parent
#                @timer = Qt::Timer.new(parent);
#                connect(@timer, SIGNAL('timeout()')) {
#                        parent.getCurrentMode()
#                        setText(parent.frequency)
#		}
#                @timer.start(500);

	end
end

