#ifndef UI_CPUFREQ
#define UI_CPUFREQ
#include "../main.h"
#include "ui_popupdialog.h"
#include "Ui_PlasmaTools.h"
#include <Plasma/Dialog>
namespace Ui {
	class CpuFreq : public Plasma::Dialog,  Ui_popupdialog {
		Q_OBJECT
		PlasmaCpufreq *top;
		public:
			QList<plasma_tools::FrequencyMap> freqmap;
			CpuFreq(PlasmaCpufreq *_top);// : QGraphicsWidget(), top(_top);
				// Create a tabwidget
				// Create 4 tabs. Last tab contains label with gpl.
				// first tab contains list of cpus.
				// second tab contains list of governors
				// third tab contains lit of frequencies
				// When item in list is clicked on, catch signal, call cpufreq-set with information available.
			
		public slots:
			void changedSelectionfreq(QListWidgetItem*sel) {
				if(!sel) return;
				ChangedSelection(sel->text());
			};
			void changedSelectioncpu(QListWidgetItem*sel) {
				if(!sel) return;
				int lastnum = 0;
				int count = 1;
				for(;count < sel->text().size(); count++ ){
					bool ok = false;
					int num = sel->text().right(count).toInt(&ok, 10);
					if(!ok) break;
					lastnum = num;
				}
				top->cpu = lastnum;
			};
			void changedSelectiongov(QListWidgetItem*sel) {	
				if(!sel) return;
				ChangedSelection(sel->text());
			}
			void fillCpuListView(QList<QString> list) { 
				for(QList<QString>::iterator iter = list.begin(); iter != list.end(); iter++) 
					cpulistView->addItem(*iter);
			};
			void fillFreqListView(QList<plasma_tools::FrequencyMap> map, QList<QString> list) {
				freqmap = map;
				for(QList<QString>::iterator iter = list.begin(); iter != list.end(); iter++) 
					freqlistView->addItem(*iter);
			};
			void fillGovListView(QList<QString> list){
				for(QList<QString>::iterator iter = list.begin(); iter != list.end(); iter++) 
					govlistView->addItem(*iter);
			};
			void ChangedSelection(QString selection); // parse selection, frequency or governor, pretty easy to tell....
			
	};

}
#endif
