/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#ifndef VIDEO_CAPTURE_BIN_H
#define VIDEO_CAPTURE_BIN_H
#include <QList>
#include <QSize>
#include "libqtgstreamer/qgstbin.h"
typedef struct _GstBuffer GstBuffer;

class VideoCaptureBin;
typedef QSharedPointer<VideoCaptureBin> VideoCaptureBinPtr;

class VideoCaptureBinPrivate;
class VideoCaptureBin : public QtGstreamer::QGstBin
{
    Q_OBJECT
    Q_DISABLE_COPY(VideoCaptureBin)
public:
    friend class VideoCaptureBinPrivate;
    
    static VideoCaptureBinPtr createVideoCaptureBin();

    virtual ~VideoCaptureBin();

    static bool bufferProbe(GstPad *pad,GstBuffer *buffer,VideoCaptureBin *videoBin);
    void newTimeStamp();
    void start();
    void stop();
    void newDevice(const QString &driver, const QString &devicePath);
    void queryDeviceData();
    void updateCapabilities(const QSize &targetSize,const QSize &frameRate);
    QList<QSize> getSupportedResolution() const;
    QList<QSize> getSupportedFrameRate(const QSize &resolution) const;
    void setBrightness(int level);
    int brightness();
    void setContrast(int level);
    int contrast();
    void setSaturation(int level);
    int saturation();
    void setHue(int level);
    int hue();

protected:
    VideoCaptureBin();

private:
    VideoCaptureBinPrivate *const d;

};

#endif