/*
 * This file is part of the KDE project
 * Copyright (C) 2009 Eva Brucherseifer <eva.brucherseifer@basyskom.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef APPLET_KILLSWITCH_HEADER
#define APPLET_KILLSWITCH_HEADER

#include "killswitchmanager.h"
#include "killswitchdevice.h"


#include <KIcon>

#include <Plasma/Applet>
#include <Plasma/Svg>

class QSizeF;
class KillSwitchItem;
class QGraphicsGridLayout;
 
// Define our plasma Applet
class PlasmaKillSwitch : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        PlasmaKillSwitch(QObject *parent, const QVariantList &args);
        ~PlasmaKillSwitch();

        /* reimp Plasma::Applet */
        void init();

        // The paintInterface procedure paints the applet to screen
        /*void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);*/
    
    public slots:
       void configAccepted();

    protected:
        void createConfigurationInterface(KConfigDialog *parent);


    private:
        void buildLayout();

        QGraphicsGridLayout *m_layout;
        Plasma::Svg m_svg;
        KIcon m_icon;

        KillSwitchManager m_rfkillmgr;
        QList<KillSwitchDevice*> m_rfkilldevices;
        QList<QGraphicsWidget*> m_widgets;
};
 
// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(killswitch, PlasmaKillSwitch)
#endif
