/***************************************************************************
 *   Copyright (C) 2009 by Björn Ruberg <bjoern@ruberg-wegener.de          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef CONTACTLISTITEM_H
#define CONTACTLISTITEM_H

#include <plasma/widgets/frame.h>
#include <plasma/widgets/label.h>
#include <plasma/widgets/iconwidget.h>


class QGraphicsGridLayout;
class Contact;
class KIcon;

class ContactListItem : public Plasma::Frame
{
    Q_OBJECT
public:
    ContactListItem(QGraphicsWidget *parent, Contact *contact);
    ~ContactListItem();
    void setIcon(KIcon* icon);
    void setNick(QString text);
    void setVisible(bool);
protected Q_SLOTS:
    void activated();
private:
    QGraphicsGridLayout* m_layout;
    Plasma::Label* nick;
    Plasma::Label* message;
    Plasma::IconWidget* avatar;
    Contact* m_contact;

};

#endif // CONTACTLISTITEM_H
