/******************************************************************************
* Copyright (C) 2008 Ian Monroe <ian@monroe.nu>
* Copyright (C) 2008 Peter ZHOU <peterzhoulei@gmail.com>
* Copyright (C) 2009 by Michal Dutkiewicz <emdeck@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#ifndef ROOT_DBUS_HANDLER_H
#define ROOT_DBUS_HANDLER_H

#include <QObject>
#include <QDBusArgument>

struct Version
{
    quint16 major;
    quint16 minor;
};

Q_DECLARE_METATYPE(Version)

QDBusArgument &operator << (QDBusArgument &argument, const Version &version);
const QDBusArgument &operator >> (const QDBusArgument &argument, Version &version);

class RootDBusHandler : public QObject
{
    Q_OBJECT

    public:
        RootDBusHandler(QObject *parent);

    public Q_SLOTS:
        void Quit();
        QString Identity();
        Version MprisVersion();
};

#endif
