/***************************************************************************
 *   Copyright (C) 2008 by Matej Svejda <mata@aw-modell.at>                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PEACHY_APPLET
#define PEACHY_APPLET

#include <Plasma/Applet>
#include <Plasma/Svg>
#include <taskmanager/taskmanager.h>

#include <QHash>

class QSizeF;
class PeachyIcon;
class PeachyLayout;
class PeachyAnimator;
class PeachyIcon;

using TaskManager::TaskPtr;

class PeachyApplet : public Plasma::Applet
{
	Q_OBJECT
	public:
		PeachyApplet(QObject *parent, const QVariantList &args);
		~PeachyApplet();
		void init();
		void hoverLeaveEvent(QGraphicsSceneHoverEvent* e);
	private slots:
		void addWindowTask(TaskPtr task);
		void removeWindowTask(TaskPtr task);
		void updateLayout();
		
		//void loadTasksForDesktop(int desktop);
	private:
		PeachyLayout* m_layout;
		PeachyAnimator* m_animator;
		void reload();
		QHash<TaskPtr, PeachyIcon*> m_tasksHash;
		
};

#endif
