/***************************************************************************
 *   Copyright (C) 2008 by Matej Svejda <mata@aw-modell.at>                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PEACHY_LAYOUT
#define PEACHY_LAYOUT

#include <QGraphicsLinearLayout>
#include <QList>

class PeachyIcon;
class PeachyApplet;
class QRectF;
class QSizeF;
class QGraphicsLayoutItem;

class PeachyLayout : public QGraphicsLinearLayout
{
	public:
		PeachyLayout(PeachyApplet* parent);
		~PeachyLayout();
		virtual QGraphicsLayoutItem* itemAt(int i) const;
		virtual int count() const;
		virtual void setGeometry(const QRectF& rect);
		virtual void removeAt(int i);
		virtual QSizeF sizeHint(Qt::SizeHint hint, const QSizeF& size) const;
		void add(PeachyIcon* icon);
		void remove(PeachyIcon* icon);
		void clear();
		void setBorderSpacing(qreal spacing);
	private:
		QList<PeachyIcon*> m_icons;
		qreal m_borderSpacing;
		qreal m_maximumIconSize;
};

#endif
