/***************************************************************************
 *   Copyright (C) 2009 by Kai Dombrowe <just89@gmx.de>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PROXYLAYOUT_H
#define PROXYLAYOUT_H


// Qt
#include <QGraphicsLayout>


namespace Plasma {
    class Animation;
}


class ProxyLayout : public QGraphicsLayout
{


public:
    ProxyLayout(QGraphicsWidget *widget, QGraphicsLayoutItem *parent = 0);
    ~ProxyLayout();

    int count() const;
    QGraphicsLayoutItem *itemAt(int i) const;
    
    void removeAt(int index);

    
private:
    QGraphicsWidget *m_widget;
    Plasma::Animation *m_geometryAnimation;



protected:
    void setGeometry(const QRectF &rect);

    QSizeF sizeHint(Qt::SizeHint which, const QSizeF &constraint = QSizeF()) const;


};


#endif // PROXYLAYOUT_H

