#ifndef OUTPUTFRAME_H
#define OUTPUTFRAME_H

#include <plasma/widgets/frame.h>
#include <kephal/outputs.h>

class QGraphicsWidget;
class QGraphicsGridLayout;
class QGraphicsLinearLayout;
class QButtonGroup;

namespace Plasma {
    class Label;
    class ComboBox;
    class RadioButton;
}


class OutputFrame : public Plasma::Frame
{
    Q_OBJECT
public:
    OutputFrame(Kephal::Output* output, QGraphicsWidget *parent=0);
    ~OutputFrame();
    Kephal::Output* output();

private:

    bool changed();

public Q_SLOTS:
    void init();
    /*void resize( int index );
    void changeRate( int index );*/
    void acceptConfiguration();
    void selectResolution();
    void selectRate();
    void selectOrientation();
    void setChanged();
    void setUnChanged();

private:
    bool m_changed;

    QGraphicsGridLayout* m_layout;
    QGraphicsLinearLayout* m_buttonline;
    QButtonGroup* m_buttongroup;
    //Plasma::Label* vendor_label;
    Plasma::Label* refresh_label;
    Plasma::Label* resolution_label;
    Plasma::Label* orientation_label;
    Plasma::ComboBox* resolution_selector;
    Plasma::ComboBox* refresh_selector;
    Plasma::RadioButton* button_normal;
    Plasma::RadioButton* button_right;
    Plasma::RadioButton* button_inverted;
    Plasma::RadioButton* button_left;
    Kephal::Output* m_output;
};

#endif // OUTPUTFRAME_H
