//the applet doesn't come with a layout, so we always have to create one first
layout = new LinearLayout(plasmoid);
layout.orientation = QtVertical;

//---------------------------------
//Task class

//constructor
function Task(name) {
    this.icon = new IconWidget();
    this.icon.text = name;
    this.icon.setIcon("flag-red");
    //text beside icon
    this.icon.orientation = QtHorizontal;
    layout.addItem(this.icon);

    //keep track of our state
    this.progress = 0;
    //"moreProgress" and this.moreProgress mean the same thing here
    this.icon.clicked.connect(this, "moreProgress");
}

//reset to 0
Task.prototype.reset = function() {
    print("reset");
    this.icon.setIcon("flag-red");
    this.progress = 0;
}

//increment the flag
Task.prototype.moreProgress = function() {
    print("click");
    print(this.progress);
    switch (this.progress) {
        case 0:
            this.icon.setIcon("flag-yellow");
            this.progress = 1;
            break;
        case 1:
            this.icon.setIcon("flag-green");
            this.progress = 2;
            break;
        default:
            this.icon.setIcon("flag-red");
            this.progress = 0;
            break;
    }
}

//---------------------------------
//set up tasks
numTasks = 0;
tasks = [];

addTask = function(name)
{
    tasks[numTasks] = new Task(name);
    numTasks++;
}

addTask(plasmoid.readConfig("label"));
addTask("foobar");

//---------------------------------
//get data from a dataengine

plasmoid.dataUpdated = function(source,data)
{
    for (var i in tasks) {
        tasks[i].reset();
    }
}
engine = dataEngine("time");
engine.connectSource("Local", plasmoid, 10*1000);

//----------------------------------
//keep up with config changes
plasmoid.configChanged = function()
{
    tasks[0].icon.text = plasmoid.readConfig("label");
}


