/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
#ifndef UI_WELCOME_CPP
#define UI_WELCOME_CPP

#define USE_LAUNCHERS 1

/* USECORONA - Use a Plasma::Corona to allocate a containment */
#define USECORONA 1
/* USE_CONTAINMENTWIDGET Make the containment be inside a graphicswidget with a layout */
#define USE_CONTAINMENTWIDGET 1


#include <assert.h>
#include "../includes/Ui_WelcomeTab.h"
#include "../includes/Ui_Dialog.h"
#include <Plasma/Containment>
#include "../welcome.h"
#include <Plasma/Corona>
#include <iostream>
#include <KAuthorized>
#include <QGraphicsItem>
#include <QList>
#include <QObject>
#include <QStyleOptionGraphicsItem>
#include <QTimer>

#include <KDialog>
#include <KIcon>

#include <Plasma/Containment>
#include <Plasma/Animator>
#include <Plasma/View>
#include <limits>

#include <QAction>
//#include <QGraphicsProxyWidget>
#include <QFile>
#include <QFileInfo>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QPainter>
#include <QTimeLine>

#include <KAuthorized>
#include <KComboBox>
#include <KDebug>
#include <KFileDialog>
#include <KImageFilePreview>
#include <KRun>
#include <KStandardDirs>
#include "kseparator.h"
#include <KWindowSystem>
#include <kservice.h>
#include <kservicetypetrader.h>


#include <Plasma/Corona>
#include <Plasma/Animator>
#include <Plasma/Theme>
#include <Plasma/Slider>

#include "kworkspace/kworkspace.h"
//#include "knewstuff2/engine.h"
//#include "containment/panel.h"

using namespace Plasma;

namespace welcome_plasmoid {

	class WelcomeResizer : public QGraphicsWidget {
		Q_OBJECT
		public:
		QGraphicsWidget *resizethis;
		bool down;
		QGraphicsWidget *resizethistoo;
		QGraphicsGridLayout *layout;
		WelcomeResizer(QGraphicsWidget *top, QGraphicsWidget *rtop,  QGraphicsGridLayout *_layout) : QGraphicsWidget(), resizethis(top), layout(_layout) {
//			KSeparator *kseparator = new KSeparator();
//			//    kseparator->setGeometry(QRect(210, 40, 111, 16));
//			kseparator->setCursor(QCursor(Qt::SizeVerCursor));
//			down = false;
//			setWidget(kseparator);
//			connect(this, SIGNAL(mouseRelease()), rtop, SIGNAL(resizeMouseRelease()));
			Plasma::Slider *m_zoom = new Plasma::Slider(this);
			
			m_zoom->connect(m_zoom, SIGNAL(sliderMoved(int)), this, SLOT(zoom(int)));
                        m_zoom->connect(m_zoom, SIGNAL(valueChanged(int)), this, SLOT(zoom(int)));

                        m_zoom->setMinimum(0);
			m_zoom->setMaximum(1200);


                        m_zoom->setOrientation(Qt::Horizontal);
			QGraphicsLinearLayout *ml = new QGraphicsLinearLayout(Qt::Vertical, this);
			ml->addItem(m_zoom);
		}
		void resizeEvent(QGraphicsSceneResizeEvent *event) {
			       		}
		public	slots:
		void zoom(int value) {
				value += 90;
				QSizeF pref;  
				if(resizethis) 
					pref = resizethis->preferredSize();
				pref.setHeight((value));
				pref.setWidth(167722);
				if(resizethis) {
					resizethis->setMaximumSize(pref);
					resizethis->setPreferredSize(pref);
//					resizethis->resize(resizethis->size().width(), pref.height());
				} 
				layout->invalidate();
				layout->activate();
		}
		signals:
			void mouseRelease();
	};
	class WelcomeTabPrivate;
	class WelcomePanel : public QGraphicsWidget {
		Q_OBJECT
			friend class WelcomeTabPrivate;
		protected:
			WelcomeResizer *resizer; 
			Plasma::Applet *containment;	
		public:
			~WelcomePanel() {
				std::cout << "Welcome Panel Destructor.\n";
				if(containment) {
//					containment->setParentItem(NULL);
					delete containment;
				}
				delete resizer;
			}
			WelcomePanel(QGraphicsWidget *parent, QGraphicsGridLayout *lay=0)
			    : QGraphicsWidget(parent)
			{
				containment = Plasma::Applet::load("floatpanel");
				resizer = new WelcomeResizer(containment, this, lay);	
			}
			public:
			class appHelper : public Plasma::Containment {
				public:
					void emitAppletAdded(Plasma::Applet *applet, const QPointF &pos) { emit appletAdded(applet, pos); }
			};
			signals:
				void resizeMouseRelease();
			public slots:
			 
			void resizeEvent(QGraphicsSceneResizeEvent *event) {
				QGraphicsWidget::resizeEvent(event);
			}

			void onAppletAdded(Plasma::Applet *applet, const QPointF &pos)
			{
				kDebug() << "Applet Added\n";
			}

			void onAppletRemoved(Plasma::Applet *applet)
			{

			}
	};

        class WelcomeTabPrivate : public QObject {
                Q_OBJECT
		friend class WelcomeTab;
                Ui_WelcomePlasmoid *top;
		WelcomeTab *welcome;
                public:
		QGraphicsGridLayout *myLayout;
#ifdef USE_LAUNCHERS
		GloweyIcon *commandIcon1;
		GloweyIcon *commandIcon2;
		GloweyIcon *commandIcon3;
		GloweyIcon *commandIcon4;
		QAction *action1;
		QAction *action2;
		QAction *action3;
		QAction *action4;
#else
		WelcomePanel *container;

#endif	

		KConfigGroup cg;
		GloweyLabel *welcomelabel;
		QGraphicsWidget *tipFrame;
		Plasma::IconWidget *tipNext;
		Plasma::IconWidget *tipPrev;
		QGraphicsLinearLayout *tipLayout;
		QGraphicsWidget *welcomeFrame;

		QGraphicsWidget *commandFrame;
#ifdef USE_LAUNCHERS
		QGraphicsLinearLayout *commandLayout;
#else
		QGraphicsGridLayout *commandLayout;
#endif
		QGraphicsGridLayout *blankLayout;
		QGraphicsWidget *blankWidget;
		QTimer *postConfig;
                WelcomeTabPrivate(Ui_WelcomePlasmoid *t, WelcomeTab *w) : top(t), welcome(w) {

			blankWidget = new QGraphicsWidget();
			tipFrame = new TransparentFrame(t);
//			tipFrame->setMinimumSize(0,24);
			blankLayout = new QGraphicsGridLayout();
			blankLayout->addItem(blankWidget, 0,0);
			blankLayout->invalidate();
			blankLayout->activate();

			tipLayout = new QGraphicsLinearLayout(Qt::Horizontal,tipFrame);

		};
                ~WelcomeTabPrivate() {
#ifndef USE_LAUNCHERS
			delete container;
#endif
		};
                void setupUi() {	
			postConfig = new QTimer();
			welcomeFrame = new QGraphicsWidget();
			welcomeFrame->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
			welcomeFrame->hide();
			myLayout = new QGraphicsGridLayout(welcomeFrame);

			cg = top->top->config();

			tipNext = top->addToolNoLayout("go-next-page");
			tipPrev = top->addToolNoLayout("go-previous-page");
			
			welcomelabel = new GloweyLabel();
			welcomelabel->setup(top, true, true);

#ifndef USE_LAUNCHERS
			commandFrame = new QGraphicsWidget(0);
			commandLayout = new QGraphicsGridLayout(commandFrame);
			commandFrame->setLayout(commandLayout);
#endif

			welcomelabel->labelWidget->setAlignment(Qt::AlignLeft|Qt::AlignTop);
#ifdef USE_LAUNCHERS
			GloweyIcon *commandIcon2 = new GloweyIcon(top);
			GloweyIcon *commandIcon3 = new GloweyIcon(top);
			GloweyIcon *commandIcon4 = new GloweyIcon(top);
			GloweyIcon *commandIcon1 = new GloweyIcon(top);

			commandFrame = new TransparentFrame(top);
			commandLayout = new QGraphicsLinearLayout(Qt::Horizontal,commandFrame);
			commandFrame->setLayout(commandLayout);


			QSizeF iconsize = commandIcon4->sizeFromIconSize(IconSize(KIconLoader::Desktop));
			iconsize = iconsize*2;
			action1 = new QAction(KIcon(cg.readEntry("Command Icon 1", "utilities-terminal")), 
				cg.readEntry("Command Name 1", "Konsole"), top);
			commandIcon1->setAction(action1);
			commandIcon1->setPreferredSize(iconsize);

			action2 = new QAction(KIcon(cg.readEntry("Command Icon 2", "utilities-log-viewer")), 
				cg.readEntry("Command Name 2", "System Logs"), top);
			commandIcon2->setAction(action2);
			commandIcon2->setPreferredSize(iconsize);

			action3 = new QAction(KIcon(cg.readEntry("Command Icon 3", "preferences-system")), 
				cg.readEntry("Command Name 3", "System Settings"), top);
			commandIcon3->setAction(action3);
			commandIcon3->setPreferredSize(iconsize);

			action4 = new QAction(KIcon(cg.readEntry("Command Icon 4", "system-file-manager")), 
				cg.readEntry("Command Name 4", "Package Manager"), top);
			commandIcon4->setAction(action4);
			commandIcon4->setPreferredSize(iconsize);




			commandLayout->addItem(commandIcon4);
			commandLayout->addItem(commandIcon3);
			commandLayout->addItem(commandIcon2);
			commandLayout->addItem(commandIcon1);

		//	commandLayout->setAlignment(commandIcon1, Qt::AlignHCenter|Qt::AlignVCenter|Qt::AlignTop);
		//	commandLayout->setAlignment(commandIcon2, Qt::AlignHCenter|Qt::AlignVCenter|Qt::AlignTop);
		//	commandLayout->setAlignment(commandIcon3, Qt::AlignHCenter|Qt::AlignVCenter|Qt::AlignTop);
		//	commandLayout->setAlignment(commandIcon4, Qt::AlignHCenter|Qt::AlignVCenter|Qt::AlignTop);

			commandLayout->insertStretch(3, 1);
			commandLayout->insertStretch(2, 1);
			commandLayout->insertStretch(1, 1);
			commandLayout->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
			commandFrame->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);

			commandLayout->invalidate();
			commandLayout->activate();

			connect(commandIcon1->action(), SIGNAL(triggered()), this, SLOT(actionSlot1()));
			connect(commandIcon2->action(), SIGNAL(triggered()), this, SLOT(actionSlot2()));
			connect(commandIcon3->action(), SIGNAL(triggered()), this, SLOT(actionSlot3()));
			connect(commandIcon4->action(), SIGNAL(triggered()), this, SLOT(actionSlot4()));


#endif

			welcomelabel->setLabelText("<html><body><p style=\" margin-top:0px; margin-bottom:0px; margin-left:15px; margin-right:15px; -qt-block-indent:0; text-indent:0px;\"><br>Congratulations, you are now running <b>KDE 4.2</b>, currently one of the worlds most advanced Desktop Environments.<br><br>The 4-series of <b>KDE</b> offers many new <b>features and improvements</b> and is aimed to be friendly in terms of usability while staying <b>aesthetically pleasing</b></p></body></html>");

#ifndef USE_LAUNCHERS
			QVariantList args;
			args << "containment-welcome";
			container = new WelcomePanel(commandFrame, commandLayout);

			//setupApplets();
			postConfig->start(1);
			QGraphicsWidget *cframe = new QGraphicsWidget(0);
			QGraphicsLinearLayout *cLayout = new QGraphicsLinearLayout(Qt::Horizontal, cframe);
			cLayout->addItem(container->containment);
			cLayout->setAlignment(container->containment, Qt::AlignBottom);

			commandLayout->addItem(container->resizer, 1,0);
			commandLayout->addItem(cframe, 0, 0);

			commandLayout->setRowMaximumHeight(1, 24);
			commandLayout->setRowSpacing(0, 0);
			commandLayout->setColumnStretchFactor(0, 0);
			commandLayout->setColumnStretchFactor(1, 1);
//			commandLayout->setColumnStretchFactor(2, 1);
#endif
			//QGraphicsWidget *mainLayoutSpacer = new QGraphicsWidget();
			//mainLayoutSpacer->setMaximumSize(167722, 167722);
			//mainLayoutSpacer->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);

			//QGraphicsWidget *fakewidg2 = new QGraphicsWidget();
			//tipLayout->addItem(fakewidg2);
			tipLayout->addStretch(1);
			tipLayout->addItem(tipPrev);


			GloweyIcon *didYouKnow = new GloweyIcon(top);
			QAction *didYouKnowAction = new QAction(KIcon("kde"), QApplication::translate("tOTDDialog", "Did you know...", NULL, QApplication::UnicodeUTF8), top);
			didYouKnow->setAction(didYouKnowAction);
			didYouKnow->setMinimumSize(didYouKnow->sizeFromIconSize(IconSize(KIconLoader::Toolbar)));
			didYouKnow->setMaximumSize(didYouKnow->sizeFromIconSize(IconSize(KIconLoader::Toolbar)));
			tipLayout->addItem(didYouKnow);

			// Add an image in the center right here
			tipLayout->addItem(tipNext);
			tipLayout->setAlignment(tipNext, Qt::AlignVCenter);
			tipLayout->setAlignment(tipPrev, Qt::AlignVCenter);
			tipLayout->addStretch(1);
			//QGraphicsWidget *fakewidg1 = new QGraphicsWidget();
			//tipLayout->addItem(fakewidg1);


			commandLayout->invalidate();
			commandLayout->activate();

			tipLayout->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
			tipLayout->activate();
			welcomelabel->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
			myLayout->addItem(tipFrame, 0,0);
			myLayout->addItem(welcomelabel, 1,0);
			myLayout->addItem(commandFrame, 2,0, Qt::AlignBottom|Qt::AlignHCenter|Qt::AlignVCenter);
//#ifdef USE_LAUNCHERS
//			myLayout->setColumnStretchFactor(0, 1);
//			myLayout->setColumnStretchFactor(1, 2);
//			myLayout->setColumnStretchFactor(2, 1);
//#endif
			myLayout->setRowStretchFactor(0, 2);
                        myLayout->setRowStretchFactor(1, 3);
                        myLayout->setRowStretchFactor(2, 1);

			commandLayout->invalidate();
			commandLayout->activate();
			myLayout->invalidate();
			myLayout->activate();

			connect(top->tabWidget, SIGNAL(currentChanged(int)), this, SLOT(mainTabChanged(int)));
			connect(tipNext->action(), SIGNAL(triggered()), this, SLOT(nextTip()));
			connect(tipPrev->action(), SIGNAL(triggered()), this, SLOT(prevTip()));
#ifndef USE_LAUNCHERS

			connect(container, SIGNAL(resizeMouseRelease()), this, SLOT(resizeMouseRelease()));
#endif
			connect(top->top, SIGNAL(configChanged()), this, SLOT(configChanged()) ) ;
			connect(didYouKnow->action(), SIGNAL(triggered()), this, SLOT(nextTip()));
			connect(postConfig, SIGNAL(timeout()), this, SLOT(postConfigChanged()));

                }
                void invalidateLayouts() {
                }
		class minih {
			public:
				QString name;
				QPointF position;
				minih(QString in) { name = in; }
		};
		void setupApplets() {
//			QVariantList defaults;
//			defaults << "launcher" << QPointF(-1,-1);
//			bool isString = true;
//			QList<minih> mlist;
//			
//			foreach(QVariant app, cg.readEntry("Default Applet", defaults)) {
//				if(isString) {
//					
//					mlist << minih( app.toString());
//					isString = false;
//				} else {
//					mlist.back().position = app.toPointF();
//					isString = true;
//				}
//			}
//			foreach(minih a, mlist) {
//#ifdef USECORONA
//				kDebug() << "Adding applet " << a.name << "\n";
//				std::cout << "Containment is a containment? : " << container->containment->isContainment() << "\n";
//				std::cout  << "Applet is: " << (container->containment)->addApplet(a.name) <<"\n";
//				std::cout  << "Applet is: " << ((welcome_plasmoid::Panel*)container->containment)->addApplet(a.name) <<"\n";
//				continue;
//#else
//				Plasma::Applet *app = Plasma::Applet::load(a.name);
////				//container->containment->addApplet(app, a.position, true);
//				container->containment->addApplet(app, a.position, false);
//				(container->containment)->layoutApplet(app, a.position);
//				app->init();

//#endif
//			}
		}
		protected slots:
			void resizeMouseRelease() {
#ifndef USE_LAUNCHERS
				cg.writeEntry("Embed Pref Y", container->preferredSize().height());
#endif
				top->top->saveConfig();	
			} 
			void postConfigChanged() {
				postConfig->stop();
#ifndef USE_LAUNCHERS
				setupApplets();
#endif
			}
			void configChanged() {
//				container->onAppletRemoved((Plasma::Applet*)container->m_layout->itemAt(0));
//				container->containment->clearApplets();
				postConfig->start(1);
#ifdef USE_LAUNCHERS
				action1->setIcon(KIcon(cg.readEntry("Command Icon 1", "utilities-terminal")));
				action1->setText(cg.readEntry("Command Name 1", "Konsole"));
				action2->setIcon(KIcon(cg.readEntry("Command Icon 2", "utilities-log-viewer")));
				action2->setText(cg.readEntry("Command Name 2", "System Logs"));
				action3->setIcon(KIcon(cg.readEntry("Command Icon 3", "preferences-system")));
				action3->setText(cg.readEntry("Command Name 3", "System Settings"));
				action4->setIcon(KIcon(cg.readEntry("Command Icon 4", "system-file-manager")));
				action4->setText(cg.readEntry("Command Name 4", "Package Manager"));
#endif
			}
#ifdef USE_LAUNCHERS
			void actionSlot1() {
				QString action = "command:/";
				action.append(cg.readEntry("Command Exec 1", "konsole"));
				top->setCurrentUrl(action);
			}
			void actionSlot2() {
				QString action = "command:/";
				action.append(cg.readEntry("Command Exec 2", "ksystemlog"));
				top->setCurrentUrl(action);
			}
			void actionSlot3() {
				QString action = "command:/";
				action.append(cg.readEntry("Command Exec 3", "systemsettings"));
				top->setCurrentUrl(action);
			}
			void actionSlot4() {
				QString action = "command:/";
				action.append(cg.readEntry("Command Exec 4", "kpackage"));
				top->setCurrentUrl(action);
			}
#endif
			void nextTip() {
				if(top->top->isHtml()) {
					top->setCurrentUrl(cg.readEntry("Default Tipfile", ""));
				} else {
					welcomelabel->setLabelText(top->top->nextTip());
				}
			}
			void prevTip() {
				if(top->top->isHtml()) {
					top->setCurrentUrl(cg.readEntry("Default Tipfile", ""));	
				} else {
					welcomelabel->setLabelText(top->top->prevTip());
				}
			}
		void mainTabChanged(int index) {
			static bool self = false;
			if(self == true) return;
			self = true;

			if(index == 0) {
				if( !cg.readEntry("Use Tab On Welcome", false) ) { 
					if(top->tabWidget->isVisible() ) {	
						top->gridLayout->removeItem(top->tabWidget); 
						top->tabWidget->hide();
						top->gridLayout->invalidate();
					}	
				} else {
					if(!top->tabWidget->isVisible() ) {
						top->gridLayout->insertItem(1, top->tabWidget); 
						top->gridLayout->invalidate();
						top->gridLayout->activate();
                                                top->tabWidget->show();
                                        }

				}
				if(!welcomeFrame->isVisible())  {
					welcomeFrame->show();
					top->gridLayout->addItem(welcomeFrame);
					myLayout->invalidate();
					myLayout->activate();
				}

			} else {
				if(welcomeFrame->isVisible() ) {
					welcomeFrame->hide();
					top->gridLayout->removeItem(welcomeFrame);
				}
				if(!top->tabWidget->isVisible() ) {
					if(  (index == 0 && cg.readEntry("Use Tab On Welcome",false)) ||(index == 1 && cg.readEntry("Use Tab On Browser", true) )  || ( index == 2 && cg.readEntry("Use Tab On Links", true) ) ) {
						top->gridLayout->insertItem(1, top->tabWidget); 
						top->gridLayout->invalidate();
						top->gridLayout->activate();
						top->tabWidget->show();
					}
				}
				top->gridLayout->invalidate();
			}
			top->top->graphicsWidget()->update();
			top->tabChanged(index);
			top->gridLayout->invalidate();
			top->gridLayout->activate();
			self = false;
		}
        };
        WelcomeTab::WelcomeTab(Ui_WelcomePlasmoid *t) : Dialog_Tools() {
                priv = new WelcomeTabPrivate(t, this);
        }
        WelcomeTab::~WelcomeTab() {
                delete (WelcomeTabPrivate*)priv;
        }
	QGraphicsGridLayout* WelcomeTab::createWelcomeTab() {
		((WelcomeTabPrivate*)priv)->setupUi();
		return ((WelcomeTabPrivate*)priv)->blankLayout;
	}
	void WelcomeTab::invalidateLayouts() {
		((WelcomeTabPrivate*)priv)->invalidateLayouts();
	}
	void WelcomeTab::retranslateUi() {
	}
	void WelcomeTab::Welcome_mainTabChanged(int index) {
		((WelcomeTabPrivate*)priv)->mainTabChanged(index);
	}
	QGraphicsWidget *WelcomeTab::welcomeFrame() {
		return ((WelcomeTabPrivate*)priv)->welcomeFrame;
	}
}
#include "../includes/Ui_WelcomeTab.moc"
#endif
