// Here we avoid loading the header multiple times
#ifndef Welcome_HEADER
#define Welcome_HEADER
// We need the Plasma Applet headers
#include <KGlobalSettings>
#include <KConfigDialog>

#include <KIcon>
 
#include <Plasma/PopupApplet>
#include <Plasma/Svg>
#include <includes/Ui_Dialog.h>
#include <includes/TipDatabase.h>
#include <ui_welcomeConfig.h>
#include <kopenwithdialog.h>
class QSizeF;
 
// Define our plasma Applet
namespace welcome_plasmoid {
	class BackgroundProxy;
}
class PlasmaWelcome : public Plasma::PopupApplet
{
    Q_OBJECT
    KOpenWithDialog *openDialog;
    QPushButton *selectedButton;
    bool autoPopup;
    public:
        // Basic Create/Destroy
        PlasmaWelcome(QObject *parent, const QVariantList &args);
        ~PlasmaWelcome();
 
        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
	void init();
	QString getTip();
	QString prevTip(); 
	QString nextTip();
	bool isHtml();
	welcome_plasmoid::TipDatabase tipdb;
	void loadConfig();
	void writeConfig();
	void applet();
	void resizeme(int x, int y);
	welcome_plasmoid::BackgroundProxy *graphics_widget;
	QGraphicsWidget *graphicsWidget();
    protected slots:
        void configAccepted();
	void selectLauncherAccepted();
    protected:
        void createConfigurationInterface(KConfigDialog *parent);
    public slots:
	void setTipDB(QString); 
	void saveConfig();
	void openLauncherDialog1();
	void openLauncherDialog2();
	void openLauncherDialog3();
	void openLauncherDialog4();
    public:
    signals:
	void configChanged();
    public:
	KConfigGroup getConfig();
	welcome_plasmoid::Ui_WelcomePlasmoid *priv;
        Plasma::Svg m_svg;
        KIcon m_icon;
	Ui::plasmaWelcomeConfig ui;
	
};
 

#endif
