/*
    Copyright (C) 2010 Kevin Krammer <kevin.krammer@gmx.at>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef AKONADIAGENTSENGINE_H
#define AKONADIAGENTSENGINE_H

#include <plasma/dataengine.h>

namespace Akonadi {
  class AgentInstance;
}

namespace Plasma {
  class Service;
}

class AkonadiAgentsEngine : public Plasma::DataEngine
{
  Q_OBJECT

  public:
    AkonadiAgentsEngine( QObject* parent, const QVariantList& args );
    ~AkonadiAgentsEngine() {}

    void init();

    QStringList sources() const;

    Plasma::Service *serviceForSource( const QString &source );

  protected:
    bool sourceRequestEvent( const QString &name );

  private Q_SLOTS:
    bool updateSourceEvent( const QString &name );

    void instanceAdded( const Akonadi::AgentInstance &agent );
    void instanceRemoved( const Akonadi::AgentInstance &agent );

    void instanceStatusChanged( const Akonadi::AgentInstance &agent );
    void instanceProgressChanged( const Akonadi::AgentInstance &agent );
    void instanceNameChanged( const Akonadi::AgentInstance &agent );
    void instanceOnlineChanged( const Akonadi::AgentInstance &agent );
};

#endif

// kate: space-indent on; indent-width 2; replace-tabs on;
