/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef CONTACTS_ENGINE_H
#define CONTACTS_ENGINE_H

#include <Plasma/DataEngine>

#include <QtCore/QMap>
#include <QtCore/QString>

#include "contact.h"

class ContactsEngine: public Plasma::DataEngine
{
Q_OBJECT

public:
	/** Constructor */
    ContactsEngine(QObject* parent, const QVariantList& args)		;

	/** Destructor */
~	ContactsEngine();

	/** Reimplemented from Plasma::DataEngine */
	QStringList sources() const;

protected:
	/** Reimplemented from Plasma::DataEngine */
	bool sourceRequestEvent(const QString &name);

	/** Reimplemented from Plasma::DataEngine */
	bool updateSourceEvent(const QString& source);

private Q_SLOTS:
	void newContact(Contact::Ptr contact);

	void contactRemoved(Contact::Ptr contact);

	void contactChanged(Contact::Ptr contact);
	
private:
	/** Known contacts */
	QMap<QString,Contact::Ptr> m_contacts;
};

#endif // CONTACTS_ENGINE_H
