/*
 *   Copyright (C) 2010 Ivan Cukic <ivan.cukic@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef GENERICLIST_H
#define GENERICLIST_H

#include <Plasma/DataEngine>
#include <Plasma/Service>
#include <Plasma/ServiceJob>
#include <QMap>

class GenericListEngine: public Plasma::DataEngine {
    Q_OBJECT

public:
    GenericListEngine(QObject * parent, const QVariantList & args);
    ~GenericListEngine();

    Plasma::Service * serviceForSource(const QString & name);

protected:
    // override DataEngine
    bool sourceRequestEvent(const QString & name);
    bool updateSourceEvent(const QString & source);
    void reload();

};

class MetaService: public Plasma::Service {
    Q_OBJECT

public:
    MetaService(QObject *parent = NULL, const QVariantList & args = QVariantList());

    virtual void registerOperationsScheme();

    virtual Plasma::ServiceJob * createJob(const QString & operation,
                QMap < QString, QVariant > & args);


private:

};

class MetaServiceJob: public Plasma::ServiceJob {
    Q_OBJECT

public:

    MetaServiceJob(const QString & operation,
            const QMap < QString, QVariant > &parameters, QObject * parent = 0);

    virtual void start();

};

#endif
