#include "recentappdocuments.h"
#include <KRecentDocument>
#include <QFileInfo>
#include <KAboutData>

RecentAppDocuments::RecentAppDocuments(QObject *parent,const QVariantList& args)
: Plasma::DataEngine(parent, args)
{
  setMinimumPollingInterval( -1 ); // no need for timming updates.
  qDebug() << "Creating";
}

void RecentAppDocuments::init()
{
  setRecentDocuments();
}

void RecentAppDocuments::setRecentDocuments(){
  foreach(const QString& recentFile, KRecentDocument::recentDocuments()){
    QFileInfo fileInfo(recentFile);
    setData(KGlobal::mainComponent().aboutData()->programName(),recentFile, fileInfo.lastModified() );
  }
}

K_EXPORT_PLASMA_DATAENGINE(recentappdocuments, RecentAppDocuments)
 
// this is needed since TestTimeEngine is a QObject
#include "recentappdocuments.moc"