/***************************************************************************
 *   Copyright (C) 2007 by Shawn Starr <shawn.starr@rogers.com>            *
 *   Copyright (C) 2008 by Petri Damstén <damu@iki.fi>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

#ifndef ION_SAVONIA_FI_H
#define ION_SAVONIA_FI_H

#include <QTimer>
#include <plasma/dataengine.h>
#include "plasma/weather/ion.h"

namespace KIO {
    class Job;
    class TransferJob;
}
class KJob;

class KDE_EXPORT SavoniaFi : public IonInterface
{
    Q_OBJECT
public:
    SavoniaFi(QObject *parent, const QVariantList &args);
    ~SavoniaFi();
    void init();
    bool timezone(void);
    void setTimezoneFormat(const QString& tz);
    bool updateIonSource(const QString& source);

public slots:
    virtual void reset();

protected slots:
    void data(KIO::Job *job, const QByteArray &data);
    void result(KJob *job);
    void clearResult();

private:
    DataEngine::Data m_data;
    QString m_result;
    QString m_source;
    QTimer m_clearTimer;
    KIO::TransferJob* m_job;
};

K_EXPORT_PLASMA_DATAENGINE(savonia_fi, SavoniaFi)

#endif
