/* Copyright (C) 2009 Jon de Andres Frias <jondeandres@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) version 3, or any
 * later version accepted by the membership of KDE e.V. (or its
 * successor approved by the membership of KDE e.V.), which shall
 * act as a proxy defined in Section 6 of version 3 of the license.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _KONQHISTORYRUNNER_H_
#define _KONQHISTORYRUNNER_H_

#include <Plasma/AbstractRunner>

#include <konq_historyprovider.h>
#include <konq_historyentry.h>
#include <KToolInvocation>
#include <KIcon>



class KonqHistoryRunner : public Plasma::AbstractRunner
{
public:
    KonqHistoryRunner(QObject *parent, const QVariantList &args);
    virtual ~KonqHistoryRunner() {};

    void match(Plasma::RunnerContext &context);
    void run(const Plasma::RunnerContext &context, const Plasma::QueryMatch &action);

private:
    KonqHistoryProvider *m_historyProvider;
    KonqHistoryList m_historyList;
    KIcon m_icon;
};

K_EXPORT_PLASMA_RUNNER(krunner_konqhistory, KonqHistoryRunner)

#endif /* _KONQHISTORYRUNNER_H_ */
