/*
 *   Copyright 2008 Aike J Sommer <dev@aikesommer.name>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2,
 *   or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#include "resizehandle.h"

#include <QPainter>
#include <QGraphicsSceneMouseEvent>

#include <KDebug>


ResizeHandle::ResizeHandle(QGraphicsItem * parent)
    : QObject(),
    QGraphicsItem(parent)
{
}

QRectF ResizeHandle::boundingRect() const {
    return QRectF(0, 0, 12, 12);
}

void ResizeHandle::paint(QPainter * p, const QStyleOptionGraphicsItem * o, QWidget * w) {
    Q_UNUSED(o);
    Q_UNUSED(w);
    
    QRectF rect(1, 1, 10, 10);
    
    p->save();
    p->setPen(Qt::white);
    p->drawRect(rect);
    p->setOpacity(0.5);
    p->fillRect(rect, p->pen().brush());
    p->restore();
}

void ResizeHandle::mousePressEvent(QGraphicsSceneMouseEvent * event) {
    if (event->button() != Qt::LeftButton) {
        event->ignore();
    }
}

void ResizeHandle::mouseMoveEvent(QGraphicsSceneMouseEvent * event) {
    //kDebug() << "mouse moved!!";
    emit dragged(event->screenPos() - event->buttonDownScreenPos(Qt::LeftButton));
}

void ResizeHandle::mouseReleaseEvent(QGraphicsSceneMouseEvent * event) {
    Q_UNUSED(event)
    
    emit released();
}

