/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KROSSRUNNERSCRIPT_H
#define KROSSRUNNERSCRIPT_H

#include <kross.h>
#include <plasma/scripting/runnerscript.h>

class KDE_EXPORT KrossRunnerScript : public Plasma::RunnerScript, KrossScriptEngine
{
    Q_OBJECT
public:
    KrossRunnerScript(QObject* parent, const QVariantList &args,
                      const QString &language);
    ~KrossRunnerScript();

    virtual bool init();
    virtual void match(Plasma::RunnerContext &context);
    virtual void run(const Plasma::RunnerContext &context,
                     const Plasma::QueryMatch &match);

public slots:
    QObject* newSearchMatch();

private:
    QString m_language;
};

#endif // KROSSRUNNERSCRIPT_H

