/*
 * Copyright 2009 Petri Damstén <damu@iki.fi>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WINDOWEDVIEW_H
#define WINDOWEDVIEW_H

#include <Plasma/View>
#include <Plasma/Corona>

class BackgroundDialog;
namespace Plasma {
    class AppletBrowser;
};

class WindowView : public Plasma::View
{
    Q_OBJECT
public:
    explicit WindowView(bool interactive = true, QWidget *parent = 0);
    virtual ~WindowView();

    void setInteractive(bool interactive);

protected slots:
    void resizeEvent(QResizeEvent *event);
    void configureContainment(Plasma::Containment *containment);
    void showAppletBrowser();
    void configDialogDestroyed();
    void appletBrowserDestroyed();

protected:
    void setToolboxVisible(bool visible);
    bool event(QEvent *event);

private:
    Plasma::Corona *m_corona;
    Plasma::Containment *m_containment;
    BackgroundDialog *m_configDialog;
    Plasma::AppletBrowser *m_appletBrowser;
    bool m_interactive;
};

#endif
