/*
 *   Copyright (C) 2007  Jon de Andres Frias <jondeandres@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 or later as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#ifndef LISTVIEW_P_H
#define LISTVIEW_P_H

#include "../scrollbar/scrollbar.h"


namespace Plasma
{
class ListView::Private
{
public:
    Private();
    ~Private();

    mutable QVector<QModelIndex> intersectVector;

    QAbstractItemModel *model;
    QPointer<QAbstractItemDelegate> delegate;
    QItemSelectionModel *selectionModel;

    Plasma::ScrollBar *verticalScrollBar;

    int maxItems;
    int baseIndex;

    int firstItem;
    int lastItem;
    int offset;
    int lastItemOffset;
    int firstItemOffset;
    int scrollPosition;


};


}

#endif
