#include "edgesource.h"

#include "edge.h"
#include "shadowitem.h"

EdgeSource::EdgeSource()
{
    m_shadow = 0;
}

EdgeSource::~EdgeSource()
{
    delete m_shadow;
}

void EdgeSource::addEdge(Edge *e)
{
    m_edges.insert(e);
}


void EdgeSource::removeEdge(Edge *e)
{
    m_edges.remove(e);
}

QVariant EdgeSource::itemChange(GraphicsItemChange change, const QVariant &value)
{
    switch (change) {
    case ItemPositionChange:
        foreach(Edge *edge, m_edges) {
            edge->adjust();
        }
        if (m_shadow)
            m_shadow->adjustPosition();
        break;
    default:
        break;
    };

    return QGraphicsItem::itemChange(change, value);
}

ShadowItem * EdgeSource::shadow() const
{
    return m_shadow;
}

void EdgeSource::setShadow(ShadowItem *item)
{
    m_shadow = item;
}
