#ifndef WINDOW_H
#define WINDOW_H

#include <QMainWindow>
#include <QTreeWidgetItem>
#include "ui_window.h"

#include "layer.h"

namespace Quasar {
    class Composition;
}
class FilterItem;
class EdgeSource;
class Window : public QMainWindow
{
    Q_OBJECT
public:
    Window();
    ~Window();

private:
    void init();

private slots:
    void viewImage();
    void filterClicked(QTreeWidgetItem * item, int column);
    void applyFiltersOnScene();
    void updatePropertyEditor();
private:
    Ui_MainWindow ui;
    Quasar::Layer m_layer;

    Quasar::Composition *m_composition;
    //QMap<QString, FilterItem*> m_filters;

    class CompositionView* m_view;
};

#endif
