#ifndef QUASAR_GRAPHICSNODE_H
#define QUASAR_GRAPHICSNODE_H

#include "node.h"

#include <QtCore/qrect.h>

namespace Quasar
{
    class GraphicsNodePrivate;
    class GraphicsNode : public Node
    {
        Q_OBJECT
        Q_DECLARE_PRIVATE(GraphicsNode)
    public:
        GraphicsNode(const QString &name);
        virtual QRectF domainOfDefinition(const QRectF &rect) const = 0;
        virtual QRectF regionOfInterest(const QRectF &rect) const = 0;

        virtual bool isGraphicsNode() const;

    protected:
        GraphicsNode(const QString &name, NodePrivate &dd);
    };
}

#endif
