/*  This file is part of the KDE project
    Copyright (C) 2008 Matthias Kretz <kretz@kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) version 3.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef QUASAR_PHONONINPUTNODE_H
#define QUASAR_PHONONINPUTNODE_H

#include "graphicsnode.h"
#include <phonon/experimental/abstractvideodataoutput.h>


namespace Quasar
{
    class PhononInputNodePrivate;
    class PhononInputNode : public GraphicsNode, public Phonon::Experimental::AbstractVideoDataOutput
    {
        Q_OBJECT
        Q_DECLARE_PRIVATE(PhononInputNode)
    public:
        PhononInputNode();
        ~PhononInputNode();

        bool execute();
        void prepare();

    protected:
        void frameReady(const Phonon::Experimental::VideoFrame2 &);
        void endOfMedia();
        bool event(QEvent *e);

        virtual QRectF domainOfDefinition(const QRectF &rect) const;
        virtual QRectF regionOfInterest(const QRectF &rect) const { return rect; }

    signals:
        void needUpdate();

    private:
        PhononInputNodePrivate *const d_ptr;
    };
}

#endif // QUASAR_PHONONINPUTNODE_H
