#include <QtTest/QtTest>
#include "composition.h"
#include "node.h"
#include "layer.h"

class DummyAddNode : public Quasar::Node
{
    Q_OBJECT
public:
    DummyAddNode()
        : Node(QLatin1String("Dummy"))
    {
        Quasar::Property prop1 = { Quasar::Property::InputProperty,

                                  QString::fromLatin1("number1"),
                                  QVariant::Double,
                                  0,
                                   QString::fromLatin1("First number"),

                                  5,
                                  0,
                                  10
        };

        Quasar::Property prop2 = { Quasar::Property::InputProperty,

                                   QString::fromLatin1("number2"),
                                   QVariant::Double,
                                   0,
                                   QString::fromLatin1("second number"),

                                   5,
                                   0,
                                   10
        };

        Quasar::Property prop3 = { Quasar::Property::OutputProperty,

                                   QString::fromLatin1("result"),
                                   QVariant::Double,
                                   0,
                                   QString::fromLatin1("Result node"),

                                   QVariant(),
                                   QVariant(),
                                   QVariant(),
        };

        addProperty("number1", prop1);
        addProperty("number2", prop2);
        addProperty("result", prop3);
    }
protected:
    virtual bool execute()
    {
        QVariant num1 = propertyValue("number1");
        QVariant num2 = propertyValue("number2");

        qreal res = num1.toDouble() + num2.toDouble();

        outputReady("result", QVariant(res));
        return num1.isValid() && num2.isValid();
    }
};

class tst_Composition : public QObject
{
    Q_OBJECT

public:
    tst_Composition();
    virtual ~tst_Composition();


public slots:
    void init();
    void cleanup();
private slots:
    void test_setting();
    void test_connections();
};


tst_Composition::tst_Composition()
{
}

tst_Composition::~tst_Composition()
{
}

void tst_Composition::init()
{
    // No initialisation is required
}

void tst_Composition::cleanup()
{
    // No cleanup is required.
}

void tst_Composition::test_setting()
{
}

void tst_Composition::test_connections()
{
}
QTEST_APPLESS_MAIN(tst_Composition)


#include "tst_composition.moc"
