#ifndef WIDGET_H
#define WIDGET_H

#include <QGLWidget>
#include <QImage>
#include <QPointF>

#include "texture.h"
#include "mesh.h"
#include "simplefilter.h"

class QMouseEvent;

class Widget : public QGLWidget
{
    Q_OBJECT
public:
    Widget(const QString &imgFile);

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);

private:
    Quasar::Texture m_tex;
    Quasar::Mesh   *m_mesh;
    QImage  m_image;
    QPointF m_point;

    SimpleFilter m_filter;
};

#endif
